#include <bits/stdc++.h>
#define ll long long
using namespace std;
int n,k,x;
void kolikoK(int a[])
{
    int br=0;
    for(int i=0;i<n-1;i++)
    {
        for(int j=i;j<n;j++)
        {
            if(abs(a[i]-a[j])>=x)br++;
        }
    }
    //cout << "broj k: " << br << endl;
    k-=br;
}
int main()
{
    ios_base::sync_with_stdio(false);

    cin >> n >> k >> x;
    int a[n];


    int kont=1,faz=2;
    if(n==k)
    {
        a[0]=1;
        a[1]=x+1;
        a[2]=x+x+1;
        cout << a[0] << " " << a[1] << " " << a[2] << " ";
        for(int i=3;i<n;i++)
        {
            a[i]=a[2]-1;
            cout << a[i] << " ";
        }

    }
    else if(n!=1 && k>0)
    {
        a[0]=1;
        a[1]=1;
        for(int i=2;i<n;i++)
        {
            if(i<k && k!=n)a[i]=1;
            else a[i]=a[i-1]+1;
        }
        /*cout << "-----" << endl;
        for(int i=0;i<n;i++)
        {
            cout << a[i] << " ";
        }
        cout << endl;*/
        kolikoK(a);
        while(k--)
        {
            a[kont]+=x;
            if(kont == n-1)
            {
                kont = faz;
                faz++;
                continue;
            }
            kont++;
        }
        for(int i=0;i<n;i++)
        {
            cout << a[i] << " ";
        }
    }
    else if(k==0 && n!=1)
    {
        for(int i=0;i<n;i++)
        {
            cout << 1 << " ";
        }
    }
    else cout << "-1";
}